<?php
require_once('../../config.php');
require_once($CFG->dirroot . '/blocks/course_duplicate/dup_form.php');
require_once($CFG->dirroot . '/local/stag/externallib.php');
require_once('curl.php');

require_once($CFG->dirroot . '/course/externallib.php');

define('STAG_REST_ROOT', $CFG->block_course_duplicate_stag);
define('_SEP_SN', $CFG->block_course_duplicate_sep_sn);         // Oddelovac pro 'Kratky nazev kurzu'
define('_SEP_FN', $CFG->block_course_duplicate_sep_fn);         // Oddelovac pro 'Cely nazev kurzu'
define('_SEP_CA', $CFG->block_course_duplicate_sep_ca);         // Oddelovac pro 'Kategorii'

function ws_stag_create_course($new_course)
{
    global $CFG, $USER;
    $token = $CFG->block_course_duplicate_token;
    $domainname = $CFG->wwwroot;
    $functionname = 'stag_create_course';
    $restformat = 'json';

    $serverurl = $domainname . '/webservice/rest/server.php'. '?wstoken=' . $token . '&wsfunction='.$functionname;
    $restformat = ($restformat == 'json')?'&moodlewsrestformat=' . $restformat:'';

    $params = array(
        "course" => $new_course,
    );

    $curl = new curl_pdv;
    $resp = $curl->post($serverurl . $restformat, $params);
    $resp = json_decode($resp);

    if (isset($resp->exception))
        throw new moodle_exception($resp->message);

    $functionname = 'stag_enrol_users';
    $userid = $USER->id;
    $roleid = $CFG->block_course_duplicate_role;
    $courseid = $resp;

    $serverurl = $domainname . '/webservice/rest/server.php'. '?wstoken=' . $token . '&wsfunction='.$functionname;

    $params = array('enrolment' => array('roleid' => $roleid, 'userid' => $userid, 'courseid' => $courseid));

    $resp2 = $curl->post($serverurl . $restformat, $params);
    $resp2 = json_decode($resp);

    if (isset($resp2->exception))
        throw new moodle_exception($resp2->message);

    return $resp;
}

function ws_stag_category_course($name, $parent = 0)
{
    global $CFG;
    $token = $CFG->block_course_duplicate_token;
    $domainname = $CFG->wwwroot;
    $functionname = 'core_course_create_categories';

    $restformat = 'json';
    $serverurl = $domainname . '/webservice/rest/server.php'. '?wstoken=' . $token . '&wsfunction='.$functionname;
    $restformat = ($restformat == 'json')?'&moodlewsrestformat=' . $restformat:'';

    $params['categories'][0]['name']= $name;
    $params['categories'][0]['parent']= $parent;

    $curl = new curl_pdv;
    $resp = $curl->post($serverurl . $restformat, $params);
    $resp = json_decode($resp);

    if (isset($resp->exception))
        throw new moodle_exception($resp->message);

    return $resp;
}

/**
 * Funkce vracejici predmety, katedry, fakulty, semestr a rok
 * ID_uzivatele, katedra, predmet, zkratka, semestr, fakulta, anotace, rok, ...
 *
 * @param type $user
 * @param type $stag_departments
 * @param type $stag_subjects
 * @param type $stag_subjects_desc
 * @param type $stag_subjects_sem
 * @param type $stag_faculty
 * @param type $stag_subjects_anot
 * @param type $stag_subjects_rok
 * @param type $stag_arr_sub_dep
 * @param type $stag_subjects_bz
 * @throws moodle_exception
 */
function stag_get_subjects($user, &$stag_departments, &$stag_subjects, &$stag_subjects_desc, &$stag_subjects_sem, &$stag_faculty, &$stag_subjects_anot, &$stag_subjects_rok, &$stag_arr_sub_dep, &$stag_subjects_bz) {
    $contents = @file_get_contents(STAG_REST_ROOT . "/ucitel/getUcitIdnoByStagLogin?stagLogin=" . $user);
    if ($contents === false) {
        throw new moodle_exception("Failed to obtain STAG id for teacher");
    }
    $xml = simplexml_load_string($contents);
    if (!$xml) {
        throw new moodle_exception("Failed to parse STAG response getUcitIdnoByStagLogin");
    }

    $id = $xml->ucitIdno;
    $contents = file_get_contents(STAG_REST_ROOT . "/predmety/getPredmetyByUcitel?ucitIdno=" . $id);
    if (empty($contents)) {
        throw new moodle_exception("Failed to obtain subject for teacher");
    }
    $xml = simplexml_load_string($contents);
    if (!$xml) {
        throw new moodle_exception("Failed to parse STAG response getPredmetyByUcitel");
    }

    foreach ($xml->predmetyUcitele->predmetUcitele as $predmet) {
        if (!in_array((string) $predmet->katedra, $stag_departments)) {
            $stag_departments[] = (string) $predmet->katedra;
        }

        $stag_arr_sub_dep[] = (string) $predmet->katedra;

        $contents = file_get_contents(STAG_REST_ROOT . "/predmety/getPredmetInfo?katedra=" . $predmet->katedra . "&zkratka=" . $predmet->zkratka);
        $contents_f = file_get_contents(STAG_REST_ROOT . "/ciselniky/getSeznamPracovist?zkratka=" . $predmet->katedra);
        if (empty($contents) || empty($contents_f))
            throw new moodle_exception("Failed to obtain subject for teacher");
        $xml = simplexml_load_string($contents);
        $xml_f = simplexml_load_string($contents_f);
        if (!$xml)
            throw new moodle_exception("Failed to parse STAG response getPredmetInfo");
        if (!$xml_f)
            throw new moodle_exception("Failed to parse STAG response getSeznamPracovist");

        if ($xml->predmetInfo->vyukaZS == "A" && $xml->predmetInfo->vyukaLS == "N")     // Pouze zimni semestr
            $stag_subjects_sem[] = "ZS";
        if ($xml->predmetInfo->vyukaZS == "N" && $xml->predmetInfo->vyukaLS == "A")     // Pouze letni semestr
            $stag_subjects_sem[] = "LS";
        if ($xml->predmetInfo->vyukaZS == "A" && $xml->predmetInfo->vyukaLS == "A")     // Letni i zimni semestr
            $stag_subjects_sem[] = "ZSiLS";

        // Pokud je typ pracoviste "F", jedna se primo o fakultu -> uvazujeme hodnotu 'zkratka',
        // v opacnem pripade se jedna o katedru -> uvazujeme hodnotu 'nadrazenePracoviste'
        if ($xml_f->pracovisteList->pracoviste->typPracoviste == "F") {
            $stag_faculty[] = (string) $xml_f->pracovisteList->pracoviste->zkratka;
        } else {
            $stag_faculty[] = (string) $xml_f->pracovisteList->pracoviste->nadrazenePracoviste;
        }

        $stag_subjects_bz[]     = (string) $predmet->nazev;
        $stag_subjects[]        = (string) $predmet->zkratka . " - " . (string) $predmet->nazev;
        $stag_subjects_desc[]   = (string) $predmet->zkratka;
        $stag_subjects_anot[]   = (string) $xml->predmetInfo->anotace;
        $stag_subjects_rok[]    = (string) $predmet->rok;
    }
}


global $PAGE, $OUTPUT, $USER, $COURSE;
require_login();
$courseid = required_param('courseid', PARAM_INT);
$course = $DB->get_record('course', array('id'=>$courseid), '*', MUST_EXIST);
$context=get_context_instance(CONTEXT_COURSE,$courseid);

$PAGE->set_context($context);
$PAGE->set_url('/blocks/course_duplication/duplicate.php');
$PAGE->set_pagelayout('admin');

$PAGE->set_heading(get_string("pluginname", "block_course_duplicate"));
$PAGE->set_title(get_string("pluginname", "block_course_duplicate"));
$PAGE->navbar->add(get_string("pluginname", "block_course_duplicate"));

$course_create = has_capability('block/course_duplicate:create',$context);
if (!$course_create) {
    require_capability('block/course_duplicate:create', $context);
}

$stag_departments   = array(get_string('none'));    // Katedry
$stag_subjects      = array(get_string('none'));    // Predmety
$stag_subjects_bz   = array(get_string('none'));    // Predmety (bez zkratek)
$stag_subjects_desc = array(get_string('none'));    // Zkratky predmetu
$stag_subjects_sem  = array(get_string('none'));    // Semestr
$stag_faculty       = array(get_string('none'));    // Fakulta
$stag_subjects_anot = array(get_string('none'));    // Anotace
$stag_subjects_rok  = array(get_string('none'));    // Rok
$stag_arr_sub_dep   = array(get_string('none'));    // Pole Predmet -> Katedra


try {
    stag_get_subjects($USER->username, $stag_departments, $stag_subjects, $stag_subjects_desc, $stag_subjects_sem, $stag_faculty, $stag_subjects_anot, $stag_subjects_rok, $stag_arr_sub_dep, $stag_subjects_bz);
} catch (Exception $e) {

}

$form = new course_dup_form(null, compact('categories', 'stag_departments', 'stag_subjects'));

$data = $form->get_data();
if ($data) {
//categories
    if ($data->stag_department > 0 && $data->stag_subject > 0 && $data->stag_year)
    {
        $cats = get_categories();
        $cat_def = $data->stag_subject;
        $masks = array(1=>$stag_faculty[$cat_def],2=>$stag_arr_sub_dep[$cat_def],3=>$stag_subjects_desc[$cat_def]);
        $depth = 1;
        $catid = 0;

        while (!empty($masks))
        {
          $mask = array_shift($masks);
          $found = false;
          foreach ($cats as $cat)
          {
            if (($cat->depth == $depth)&&($cat->name == $mask)&&($cat->parent == $catid))
            {
              $catid = $cat->id;
              $found = true;
              break;
            }
          }
          if (!$found)
          {
            $catid_tmp = ws_stag_category_course($mask, $catid);
            $catid = $catid_tmp[0]->id;
          }
          $depth++;
        }
        $data->category = $catid;
    }
    else
    {
      $data->category = $CFG->block_course_duplicate_catid;
    }

//course
    $new_course = array(
        "categoryid" => (int) $data->category,
        "shortname" => $data->shortname,
        "full_name" => $data->full_name,
        "annotation" => $data->annotation,
        "start_date" => date("Y-m-d",$data->start_date),
        "stag_sync" => (int) $data->stag_sync,
    );

    if ($data->stag_department > 0 && $data->stag_subject > 0 && $data->stag_year)
        $new_course['stag_id'] = array(array(
                "department" => $stag_departments[$data->stag_department],
                "subject" => $stag_subjects_desc[$data->stag_subject],
                "year" => $data->stag_year));

    if ($data->stag_roakidno)
        $new_course['stag_roakidno'] = $data->stag_roakidno;


    $new_id = ws_stag_create_course($new_course);

    $url = new moodle_url($CFG->wwwroot . '/course/view.php', array('id' => $new_id));
    redirect($url);
}

echo $OUTPUT->header();

if(!isset($_REQUEST['submitbutton'])) {
	$readonly_shortname=true;
    // Pokud nebylo stisknuto tlacito 'Vytvorit kurz', provede se predani PHP promennych do JS promennych. Pokud tlacitko stiknuto bylo, tato vetev se preskoci
    echo '<script type="text/javascript">' . "\n";
    echo 'var zkratka_predmet   =   ' . json_encode($stag_subjects_desc) . ';' . "\n";
    echo 'var predmet_bz        =   ' . json_encode($stag_subjects_bz) . ';' . "\n";
    echo 'var arr_rok           =   ' . json_encode($stag_subjects_rok) . ';' . "\n";
    echo 'var arr_semestr       =   ' . json_encode($stag_subjects_sem) . ';' . "\n";
    echo 'var arr_anotace       =   ' . json_encode($stag_subjects_anot) . ';' . "\n";
    echo 'var arr_faculty       =   ' . json_encode($stag_faculty) . ';' . "\n";
    echo 'var arr_sub_dep       =   ' . json_encode($stag_arr_sub_dep) . ';' . "\n";
    echo 'var sep_sn           =   "' . _SEP_SN . '";' . "\n";
    echo 'var sep_fn           =   "' . _SEP_FN . '";' . "\n";
    echo 'var sep_ca           =   "' . _SEP_CA . '";' . "\n";
//    echo 'var _alert            =   "' . ALERT . '";' . "\n";
    echo 'var readonly_shortname='.($readonly_shortname ? 'true' : 'false').';' . "\n";
    echo '</script>';
}

 $PAGE->requires->js('/blocks/course_duplicate/script/jquery-1.9.0.js');
 $PAGE->requires->js('/blocks/course_duplicate/script/response.js');

echo "<h1>" . get_string('pluginname', 'block_course_duplicate') . "</h1>";
$form->display();
echo $OUTPUT->footer();