<?php

defined('MOODLE_INTERNAL') || die;

require_once($CFG->libdir . '/formslib.php');

class course_attrs_form extends moodleform {
    public static $stag_attributes = array('department', 'subject', 'year', 'roakidno', 'sync', 'ver', 'template');

    function definition() {
        global $COURSE;

        $mform =& $this->_form;

        $mform->addElement('hidden', 'id', $COURSE->id);
        $mform->setType('id', PARAM_INT);

        $mform->addElement('header', "stag_id", get_string('stag_id', 'local_courses'));
        
        $mform->addElement('text', 'stag_department', get_string('stag_department', 'local_courses'));
        $mform->setType('stag_department', PARAM_TEXT);

        $mform->addElement('text', 'stag_subject', get_string('stag_subject', 'local_courses'));
        $mform->setType('stag_subject', PARAM_TEXT);

        $mform->addElement('text', 'stag_year', get_string('stag_year', 'local_courses'));
        $mform->setType('stag_year', PARAM_TEXT);

        // dalsi parametry ze stag

        $mform->addElement('header', 'stag_parms', get_string('stag_parms', 'local_courses'));

        $mform->addElement('text', 'stag_roakidno', get_string('stag_roakidno', 'local_courses'));
        $mform->setType('stag_roakidno', PARAM_TEXT);

        $mform->addElement('advcheckbox', 'stag_sync', get_string('stag_sync', 'local_courses'));
        $mform->addElement('header', "stag_adv_params", "Nová rozšíření");
        $mform->addElement('static', 'stag_ver', "Verze");
        $mform->addElement('advcheckbox', 'stag_template', "Template");

        foreach (self::$stag_attributes as $attr) {
            if (isset($this->_customdata[$attr])) {
                $var = "stag_" . $attr;
                $mform->setDefault($var, $this->_customdata[$attr]);
            }
        }

        $this->add_action_buttons(false, get_string('edit_attributes', 'local_courses'));
    }

		function validation($data,$files){
			$errors=array();

			// vsechno, nebo nic
			$stag_department=$data['stag_department'];
			$stag_subject=$data['stag_subject'];
			$stag_year=(int)$data['stag_year'];
			if(($stag_department || $stag_subject || $stag_year) && (!$stag_department || !$stag_subject || !$stag_year)){
				foreach(array('stag_department','stag_subject','stag_year') as $key){
					if(!$$key){
						$errors[$key]='Stag ID musí být zadáno buď kompletně, nebo vůbec.';
					}
				}
			}

			// rok
			$min_year=date('Y')-10;
			$max_year=date('Y')+10;
			if(!$stag_year && ($stag_department || $stag_subject)){
				if(!$stag_year){
					$errors['stag_year']='Rok je možné zadat pouze jako číselnou hodnotu.';
				}
				elseif($stag_year<$min_year || $stag_year>$max_year){
					$errors['stag_year']='Povolené rozmezí pro zadané roky je '.$min_year.' - '.$max_year.'.';
				}
			}

			return $errors;
		}
}
